/*
 * parse.h
 */

struct param {
    int len;
    char *s;
};

struct parse_context {
    int silent;
    int subst;
    char *cmdchain;
    struct param *params;
};

void parse();
int parse_walk();
int brace_balance();
void study_action_pattern();
int search_action();
int escape_command();
int escape_specials();
int unescape();
void escape_seq();
int unescape_seq();
int digit_span();
int label_span();
int print_span();
int get_token();
char *chop_label();
char *chop_arg();
char *chop_str();
char *skipspace();

